SystemOrganization addCategory: #'O-Tests-Core'!
SystemOrganization addCategory: #'O-Tests-Languages-Clojure'!
SystemOrganization addCategory: #'O-Tests-Languages-ActiveObject'!
SystemOrganization addCategory: #'O-Tests-Languages-CSPi'!

OActiveObject subclass: #OActiveObjectTestSubject
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-ActiveObject'!

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 15:53'!
a
	^ a! !

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 15:53'!
a: anA
	a := anA! !

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 15:53'!
b
	^ b! !

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 15:53'!
b: aB
	b := aB! !

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:53'!
somePassiveObj
	^ OActiveObjectTestSubject2 new.! !

OActiveObject subclass: #OpAOPingPong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-ActiveObject'!

!OpAOPingPong class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:47'!
example
	[ | ping |
		ping := OpAOPingPong new.
		ping ping. ] forkNamed: 'ping-pong-test'.! !

!OpAOPingPong methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/22/2012 14:46'!
ping
	<noReturnValue>
	Transcript log: 'ping'.
	Transcript log: 'PingPong domain: ', 
						(OstMirror domainOf: self) printString, '(', (OstMirror domainOf: self) hash asString, ')'.
	
	OpAOPingObj new printDomain.
	
	self pong.
	! !

!OpAOPingPong methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/5/2011 23:26'!
pong
	<noReturnValue>
	Transcript addEntry: 'pong'.! !

OstDomain subclass: #OstSemanticsTestDomain
	instanceVariableNames: 'record'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Core'!

!OstSemanticsTestDomain methodsFor: 'initialization' stamp: 'StefanMarr 7/28/2012 10:52'!
initialize
	super initialize.
	record := OrderedCollection new.! !

!OstSemanticsTestDomain methodsFor: 'accessing' stamp: 'StefanMarr 11/27/2011 17:31'!
record
	^ record! !

OstDomain subclass: #OstTestDomain
	instanceVariableNames: 'primitive primitiveArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Core'!

!OstTestDomain methodsFor: 'accessing' stamp: 'StefanMarr 3/24/2012 16:24'!
primitive
	^ primitive! !

!OstTestDomain methodsFor: 'accessing' stamp: 'StefanMarr 3/24/2012 16:25'!
primitiveArgs
	^ primitiveArgs! !

OstTestDomain subclass: #OstTestDomain2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Core'!

OstTestCase subclass: #CSPiChannelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-CSPi'!

!CSPiChannelTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 13:18'!
testConsecutiveSends
	| channel dummyDomain |
	dummyDomain := OstDomain new.
	channel := CSPiChannel in: dummyDomain out: dummyDomain.

	[ channel in send: 1. ] fork.
	self assert: 1 equals: channel out receive.
	
	[ channel in send: 2. ] fork.
	self assert: 2 equals: channel out receive.
	
	[ channel in send: 3. ] fork.
	self assert: 3 equals: channel out receive.
	! !

!CSPiChannelTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 13:18'!
testCreateChannel
	| channel dummyDomain |
	dummyDomain := OstDomain new.
	channel := CSPiChannel in: dummyDomain out: dummyDomain.

	[ channel in send: 1. ] fork. "Need to fork, is blocking operation"

	self assert: 1 equals: channel out receive.! !

OstTestCase subclass: #CSPiTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-CSPi'!

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 12:49'!
testBasicSetup
	
	| p1 p2 c1 c2 |
	
	p1 := CSPiPingPong newWith: #ping.
	p2 := CSPiPingPong newWith: #pong.
	
	c1 := CSPiChannel in: p1 out: p2.
	c2 := CSPiChannel in: p2 out: p1.
	
	p1 ping: c1 in.
	p1 pong: c2 out.
	
	p2 ping: c2 in.
	p2 pong: c1 out.
	
	p1 start.
	p2 start.
	
	p1 join.
	p2 join.! !

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 1/9/2012 21:59'!
testIsolationAssign
	
	| proc obj |
	obj := CSPiTestSubject new.
	proc := CSPiPingPong newWith: obj.

	"Now the obj should be adopted"
	self should: [
		[obj a: #foo] omni.
		] raise: Error.
! !

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 1/9/2012 21:58'!
testIsolationRead
	
	| proc obj |
	obj := CSPiTestSubject new.
	proc := CSPiPingPong newWith: obj.

	"Now the obj should be adopted"
	self should: [
		[obj a] omni.
		] raise: Error.
! !

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 1/9/2012 21:59'!
testIsolationReflectiveRead
	
	| proc obj |
	obj := CSPiTestSubject new.
	proc := CSPiPingPong newWith: obj.

	"Now the obj should be adopted"
	self should: [
		[obj instVarAt: 1] omni.
		] raise: Error.
! !

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 1/9/2012 21:59'!
testIsolationReflectiveWrite
	
	| proc obj |
	obj := CSPiTestSubject new.
	proc := CSPiPingPong newWith: obj.

	"Now the obj should be adopted"
	self should: [
		[obj instVarAt: 1 put: #foo] omni.
		] raise: Error.
! !

OstTestCase subclass: #OActiveObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-ActiveObject'!

!OActiveObjectTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:49'!
testActiveObjectReturnsPromise
	| ao result |
	ao := OActiveObjectTestSubject new.

	self assert: nil equals: ao a.
	
	result := [ao a: #foo] omni.
	self assert: (result isKindOf: OPromise).
	
	result := [ao a] omni.
	self assert: (result isKindOf: OPromise).
	
	result := [ao b: #foo] omni.
	self assert: (result isKindOf: OPromise).! !

!OActiveObjectTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 18:30'!
testCheckAsyncExecution
	| ao |
	ao := OActiveObjectTestSubject new.

	self assert: nil equals: ao a.
	
	"Foo should not be executed imediatly."
	[| p |
	 p := [ao a: #foo] omni.
	 self assert: (p isKindOf: OPromise).
	 self assert: nil equals: ao a.
	] valueUnpreemptively.

	Processor yield. "This works only since we assume round-robin scheduling"
	Processor yield.
	
	self assert: #foo equals: ao a.! !

!OActiveObjectTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 18:28'!
testCheckAsyncExecutionOfReflection
	| ao idxA |
	ao := OActiveObjectTestSubject new.
	idxA := OActiveObjectTestSubject instVarIndexFor: #a.
	
	
	self assert: nil equals: ao a.
	
	"Foo should not be executed imediatly."
	[[ao instVarNamed: #a put: #foo] omni.
	 self assert: nil equals: ao a.
	] valueUnpreemptively.

	Processor yield. "This works only since we assume round-robin scheduling"
	(Delay forSeconds: 1) wait.
	
	self assert: #foo equals: ao a.! !

!OActiveObjectTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:53'!
testCheckSyncExecutionOnPassiveObjects
	| ao passive result |
	ao := OActiveObjectTestSubject new.
	
	[ passive := ao somePassiveObj read] omni.

	self assert: nil equals: passive a.
	
	"Is directly executed without sending an async message."
	[[ passive a: #foo ] omni.
	 self assert: #foo equals: passive a.
	] valueUnpreemptively.
! !

OstTestCase subclass: #OstDomainTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Core'!

!OstDomainTest methodsFor: 'testing' stamp: 'StefanMarr 7/29/2012 22:22'!
expectedFailures
	(Smalltalk hasClassNamed: #OstCompiler) 
		ifTrue: [^ #(testDomainCustomizationsProperlyInitialized)]
		ifFalse:[^ #()].! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 7/22/2012 00:38'!
testAdoptNonOstObject
	| domain obj |
	domain := OstDomain new.
	
	obj := Array new: 1.
	
	self assert: nil equals: (OstMirror domainOf: obj).
	
	domain adoptObject: obj.
	
	self assert: domain equals: (OstMirror domainOf: obj).! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/22/2012 14:50'!
testAdoptObject
	| domain hello |
	domain := OstDomain new.
	
	hello := OstObject new.
	
	self assert: nil equals: (OstMirror domainOf: hello).
	
	domain adoptObject: hello.
	
	self assert: domain equals: (OstMirror domainOf: hello).! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/22/2012 14:50'!
testDomainForNewObjectsNotUsedWithoutOmnification
	| domain hello |
	domain := OstDomain new.
	
	hello := domain evaluateInContext: [ OstObject new. ].
	
	"This is expected behavior because omnification is not enabled for #evaluateInContext:"
	self assert: nil equals: (OstMirror domainOf: hello).! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/22/2012 14:50'!
testDomainForNewObjectsWithOmnification
	| domain hello |
	domain := OstDomain new.
	
	hello := [ OstObject new. ] omni: domain.
	
	"This should work since we used the #omni: entry."
	self assert: domain equals: (OstMirror domainOf: hello).! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 1/3/2012 13:23'!
testEvaluateInContext
	| domain result |
	domain := OstDomain new.
	
	"We just use the array to be sure that we got the result of the block and nothing else"
	result := domain evaluateInContext: [ { OstDomain currentDomain } ].
	
	self assert: domain equals: (result at: 1).! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/20/2012 15:50'!
testNewProcessFor
	| domain  promise block proc |
	domain := OstDomain new.
	
	promise := OPromise new.
	block := [ promise deliver: (OstDomain currentDomain) ].
	
	proc := domain newProcessFor: block.
	
	self assert: (proc isKindOf: Process).
	self assert: domain equals: (OstMirror domainOf: proc).
	
	proc resume.
	self assert: domain equals: promise read.! !

OstTestCase subclass: #OstSemanticsTest
	instanceVariableNames: 'foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Core'!

!OstSemanticsTest methodsFor: 'test helpers' stamp: 'StefanMarr 12/8/2011 22:39'!
basicReadOn: o in: aDomain
	" This one first since that is usually not optimizied by the compiler"

	self assert: 'AB' equals: ([ o aAndB ] omni: aDomain). 

	self assert: #A equals: ([ o a ] omni: aDomain).
	self assert: #B equals: ([ o b ] omni: aDomain).! !

!OstSemanticsTest methodsFor: 'test helpers' stamp: 'StefanMarr 12/8/2011 22:39'!
constReadOn: o in: aDomain
	self assert: 1   equals: ([ o return1    ] omni: aDomain).
	self assert: nil equals: ([ o returnNil  ] omni: aDomain).
	self assert: o   equals: ([ o returnSelf ] omni: aDomain).! !

!OstSemanticsTest methodsFor: 'test helpers' stamp: 'StefanMarr 12/9/2011 16:31'!
otherReadsOn: o in: aDomain
	self assert: #A equals: ([ o returnAViaTemp ] omni: aDomain).
	
	self flag: 'TODO: check whether there is a way to get this one working, by reducing the number of created temp vars'.
	[self assert: #A equals: ([ o somethingLongAndComplexReturningOriginalA ] omni: aDomain).].! !

!OstSemanticsTest methodsFor: 'running' stamp: 'StefanMarr 6/8/2013 17:20'!
setUp
	"Make sure they are compiled properly with OstCompiler.
	 We better do to much work then to few.
	 This is unfortunately executed for ever test."
	(Smalltalk hasClassNamed: #OstCompiler) ifTrue: [
		OstSemanticsTestSubject compileAll.
		OstSemanticsTest compileAll.
		OstSemanticsTestDomain compileAll.
	].! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 6/8/2013 17:20'!
testAllMethodSemanticsWithoutDomain
	| o |
	o := OstSemanticsTestSubject new.
	
	OstMirror setDomainOf: o to: nil. "Not strictly necessary, but to be explicit"
	
	self basicReadOn:  o in: nil.
	self otherReadsOn: o in: nil.
	self constReadOn:  o in: nil.
	self writesOn:     o in: nil.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 12/8/2011 23:46'!
testBasicSend
	| result |
	result := [ 1 bitOr: 2 ] omni.
	self assert: 3 equals: result.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 6/8/2013 17:20'!
testBasicSuperSend
	| o result d |
	o := OstSemanticsTestSubjectSub new.
	d := OstSemanticsTestDomain new.
	d adoptObject: o.
	result := [o b] omni: d.
	
	self assert: #B equals: result.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 12/15/2011 15:11'!
testCascadedNotInSequence
	| assoc |
	assoc := Association key: #foo value: 0.
	[ assoc value: (assoc value: 1;
	                      value: 2) ] omni.

	self assert: assoc == assoc value.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 12/13/2011 12:46'!
testCascadedOnComplexExpression2Sends
	| assoc |
	assoc := Association key: #foo value: 0.
	[ (assoc value: 3) value: (1 + 2);
			 value: assoc value + 2;
			 value: assoc value + 5 ] omni.

	self assert: 10 equals: assoc value.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 12/13/2011 12:45'!
testCascadedOnComplexExpressionSends
	| assoc |
	
	[ (assoc := Association key: #foo value: 0) value: (1 + 2);
			 value: assoc value + 2;
			 value: assoc value + 5 ] omni.

	self assert: 10 equals: assoc value.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 12/15/2011 14:59'!
testCascadedSends
	| assoc |
	assoc := Association key: #foo value: 0.
	
	[ assoc value: (1 + 2);
			 value: assoc value + 2;
			 value: assoc value + 5 ] omni.

	self assert: 10 equals: assoc value.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 12/8/2011 23:49'!
testChainedAndComplexArgumentSend
	| result |
	result := [ (1 bitOr: 2) bitOr: (8 bitOr: 16) ] omni.
	self assert: 27 equals: result.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 12/8/2011 23:47'!
testChainedSend
	| result |
	result := [ (1 bitOr: 2) bitOr: 4 ] omni.
	self assert: 7 equals: result.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 6/8/2013 17:20'!
testClosureAndInits
	| result |

	[ | o |

		o := OstSemanticsTestSubjectSub new.
		result := o ] omni.
	
	self assert: result notNil
! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 3/21/2012 18:05'!
testClosures
	| result |
	
	[ | o |
		o := Object new.
		result := o. ] omni.
	
	self assert: result notNil.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 12/8/2011 23:49'!
testComplexArgumentSend
	| result |
	result := [ 1 bitOr: (8 bitOr: 16) ] omni.
	self assert: 25 equals: result.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 6/8/2013 17:17'!
testProcessClass
	"The loading and cross-updating sometimes leads for some reason
	 to the disappearing of the omniDomain instance variable.
	
	 REM: If this test fails, execute:
		 OstDomain initialize.
	 Or make sure that you run on an OmniVM."
	
	(Smalltalk hasClassNamed: #OstCompiler)
		ifTrue: [self assert: (Process hasInstVarNamed: #omniDomain)]
	
	! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 6/8/2013 17:20'!
testProperOmnificationInClassHierarchy
	| o result |
	o := OstSemanticsTestSubject new.
	
	result := [o returnSomeConstant] omni.
	
	self assert: #super equals: result.
	
	o := OstSemanticsTestSubjectSub new.
	result := [o returnSomeConstant] omni.
	
	self assert: #sub equals: result.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 6/8/2013 17:20'!
testProperOmnificationInClassHierarchyOnClassSide
	| result |
	result := [OstSemanticsTestSubject returnSomeConstant] omni.
	
	self assert: #super equals: result.
	
	result := [OstSemanticsTestSubjectSub returnSomeConstant] omni.
	
	self assert: #sub equals: result.! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 6/8/2013 17:20'!
testReadInMixedClasses
	| result |
	
	[ | o |
		o := OstSemanticsTestSubjectSub new.
		result := o accessMixedFields. ] omni.
	
	self assert: #C equals: (result at: 1).
	self assert: #D equals: (result at: 2).! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 6/8/2013 17:20'!
testReadInSubClass
	| result |
	
	[ | o |
		o := OstSemanticsTestSubjectSub new.
		result := o accessSubclassFields. ] omni.
	
	self assert: #D equals: (result at: 1).
	self assert: #E equals: (result at: 2).
	self assert: #F equals: (result at: 3).! !

!OstSemanticsTest methodsFor: 'tests' stamp: 'StefanMarr 6/8/2013 17:20'!
testReadInSuperClass
	| result |
	
	[ | o |
		o := OstSemanticsTestSubjectSub new.
		result := o accessSuperClassFields. ] omni.
	
	self assert: #A equals: (result at: 1).
	self assert: #B equals: (result at: 2).! !

!OstSemanticsTest methodsFor: 'test helpers' stamp: 'StefanMarr 11/27/2011 17:59'!
writesOn: o
	self deny: (o a = 42).
	o a: 42.
	self assert: 42 equals: o a.
	
	self deny: (o b = 55).
	o b: 55.
	self assert: 55 equals: o b.
	! !

!OstSemanticsTest methodsFor: 'test helpers' stamp: 'StefanMarr 12/8/2011 22:41'!
writesOn: o in: aDomain
	self deny: (o a = 42).
	o a: 42.
	self assert: 42 equals: ([o a] omni: aDomain).
	
	self deny: (o b = 55).
	o b: 55.
	self assert: 55 equals: ([o b] omni: aDomain).
	! !

CSPiProcess subclass: #CSPiPingPong
	instanceVariableNames: 'role strRole inputEnd receivingEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-CSPi'!

!CSPiPingPong class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 23:55'!
newWith: pingOrPong
	| proc |
	proc := self new.
	proc role: pingOrPong.
	proc adoptObject: pingOrPong.
	^ proc.! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/9/2012 23:16'!
ping: anInputEnd
	inputEnd := anInputEnd! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/9/2012 23:17'!
pong: aReceivingEnd
	receivingEnd := aReceivingEnd! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/16/2013 13:16'!
receivePing
	| val |
	"ScriptConsole println: strRole, ': receivePing'."
	val := receivingEnd receive.
	
	"ScriptConsole println: strRole, ': receivePing completed.'."
	
	val = #ping ifFalse: [Error signal: 'Did not receive a ping but a ', val asString].! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/16/2013 13:16'!
receivePong
	| val |
	"ScriptConsole println: strRole, ': receivePong.'."
	
	val := receivingEnd receive.
	
	"ScriptConsole println: strRole, ': receivePong completed.'."
	
	val = #pong ifFalse: [Error signal: 'Did not receive a pong but a ', val asString].! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 8/2/2012 13:12'!
role: pingOrPong
	role := pingOrPong.
	strRole := role asString.! !

!CSPiPingPong methodsFor: 'process runnable' stamp: 'StefanMarr 8/2/2012 13:06'!
run
	role == #ping
		ifTrue: [
			self sendPing.
			self receivePong.
		]
		ifFalse: [
			self receivePing.
			self sendPong.
		]! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/16/2013 13:16'!
sendPing
	"ScriptConsole println: strRole, ': sendPing'."
	inputEnd send: #ping.
	"ScriptConsole println: strRole, ': sendPing done'."! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/16/2013 13:16'!
sendPong
	"ScriptConsole println: strRole, ': sendPong'."
	inputEnd send: #pong.! !

OstObject subclass: #CSPiTestSubject
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-CSPi'!

!CSPiTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 21:54'!
a
	^ a! !

!CSPiTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 21:55'!
a: anA
	a := anA! !

OstObject subclass: #OActiveObjectTestSubject2
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-ActiveObject'!

!OActiveObjectTestSubject2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:42'!
a
	^ a! !

!OActiveObjectTestSubject2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:43'!
a: anA
	a := anA! !

!OActiveObjectTestSubject2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:42'!
b
	^ b! !

!OActiveObjectTestSubject2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:42'!
b: aB
	b := aB! !

OstObject subclass: #OcjAgentTestSuject
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-Clojure'!

!OcjAgentTestSuject methodsFor: 'accessing' stamp: 'StefanMarr 1/6/2012 14:58'!
a
	^ a! !

!OcjAgentTestSuject methodsFor: 'accessing' stamp: 'StefanMarr 1/6/2012 14:58'!
a: aVal
	a := aVal! !

!OcjAgentTestSuject methodsFor: 'accessing' stamp: 'StefanMarr 1/6/2012 14:58'!
b
	^ b! !

!OcjAgentTestSuject methodsFor: 'accessing' stamp: 'StefanMarr 1/6/2012 14:58'!
b: aVal
	b := aVal! !

!OcjAgentTestSuject methodsFor: 'initialization' stamp: 'StefanMarr 1/6/2012 14:58'!
initialize
	a := #a.
	b := #b.! !

OstObject subclass: #OstSemanticsTestSubject
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Core'!

!OstSemanticsTestSubject class methodsFor: 'test helper' stamp: 'StefanMarr 1/5/2012 21:16'!
returnSomeConstant
	^ #super! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
a
	^a! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
a: anA
	a := anA! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
aAndB
	^ a, b! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
b
	^b! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
b: anB
	b := anB! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
initialize
	a := #A.
	b := #B.
	c := #C.! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
return1
	^ 1! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
returnAViaTemp
	| oldA |
	oldA := a.
	^ oldA! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
returnNil
	^ nil! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
returnSelf
	^ self! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 1/5/2012 21:10'!
returnSomeConstant
	^ #super! !

!OstSemanticsTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
somethingLongAndComplexReturningOriginalA
	| oldA and to |
	oldA := a.
	
	oldA = a ifTrue: [
		10 timesRepeat: [ a :=	#a ].
		
		and := c.
		to := b asString, c asString.
		
		"Will never happen".
		c == #abba
			ifTrue: [
				[a := self will never happen.].
				c := b + a + 10 factorial.]
			ifFalse: [
				[self this is always going to happen but this block will never be evaluated anyway,
				and we are just poluting the number of literals in this method,
				to make sure that we are not missing anything that should have been done by the compiler
				but is done wrong after we added our changes.].
				
				c := 1 + 2 + 3 + 4 + 5 + 6 + 7 + 8 + 9 + 10.
			]
		].
	
	^ oldA! !

OstSemanticsTestSubject subclass: #OstSemanticsTestSubjectSub
	instanceVariableNames: 'd e f'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Core'!

!OstSemanticsTestSubjectSub class methodsFor: 'test helper' stamp: 'StefanMarr 1/5/2012 21:16'!
returnSomeConstant
	^ #sub! !

!OstSemanticsTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 1/5/2012 20:31'!
accessMixedFields
	^ { c. d. }! !

!OstSemanticsTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 1/5/2012 20:31'!
accessSubclassFields
	^ { d. e. f }! !

!OstSemanticsTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 1/5/2012 20:30'!
accessSuperClassFields
	^ { a. b }! !

!OstSemanticsTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 12/12/2011 00:06'!
b
	^ super b! !

!OstSemanticsTestSubjectSub methodsFor: 'initialization' stamp: 'StefanMarr 1/5/2012 20:32'!
initialize
	super initialize.
	d := #D.
	e := #E.
	f := #F.! !

!OstSemanticsTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 1/5/2012 21:10'!
returnSomeConstant
	^ #sub! !

Object subclass: #OpAOPingObj
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-ActiveObject'!

!OpAOPingObj methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 19:59'!
printDomain
	Transcript log: omniDomain printString, '(', omniDomain hash asString, ')'.! !

CjAgentTest subclass: #OcjAgentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-Clojure'!

!OcjAgentTest class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/6/2012 13:01'!
shouldInheritSelectors
	^ true! !

!OcjAgentTest methodsFor: 'configuration' stamp: 'StefanMarr 1/5/2012 14:26'!
agentNew
	^ OcjAgent new! !

!OcjAgentTest methodsFor: 'configuration' stamp: 'StefanMarr 1/5/2012 14:26'!
agentNew: initialState
	^ OcjAgent new: initialState! !

!OcjAgentTest methodsFor: 'tests' stamp: 'StefanMarr 1/6/2012 12:48'!
testAwaitOmni
	| agent |
	agent := self agentNew.

	[ agent send: [:i | #noop].
	  agent send: [:i | #noop].
	  agent send: [:i | #noop].
	  agent send: [:i | #last].
	
	  agent await. ] omni. "The agent is its own domain, and we access it from another domain."
	
	self assert: #last equals: agent read.
	! !

!OcjAgentTest methodsFor: 'tests' stamp: 'StefanMarr 1/6/2012 12:49'!
testReadOmni
	| agent result |
	
	"without initial value"
	agent := self agentNew.
	self assert: nil    equals: [ agent read ] omni.
	
	"with initial value"
	agent := self agentNew: #first.
	self assert: #first equals: [ agent read ] omni.
	
	result := [
		agent send: [:i | #foo].
		agent await.
		agent read ] omni.
	self assert: #foo equals: result.! !

!OcjAgentTest methodsFor: 'tests' stamp: 'StefanMarr 1/6/2012 14:35'!
testSendOmni
	| agent result |
	agent := self agentNew: 0.
	
	self assert: 0 equals: agent read.

	result := [
		agent send: [:old | old + 1].
		agent await.
		agent read. ] omni.
	
	self assert: 1 equals: result.
	
	result := [
		agent send: [:old | old + 20].
		agent send: [:old | old + 21].
		agent await.
		agent read ] omni.
	
	self assert: 42 equals: result.
	! !

!OcjAgentTest methodsFor: 'tests' stamp: 'StefanMarr 1/6/2012 12:58'!
testSendWithOmni
	| agent incFn result |
	agent := self agentNew: 0.
	
	result := [
		incFn := [:old :inc | old + inc]. "make sure this block is omnified"
		agent read. ] omni.
	
	self assert: 0 equals: result.
	
	result := [
		agent send: incFn with: 1.
		agent await.
		agent read ] omni.
	
	self assert: 1 equals: result.
	
	result := [
		agent send: incFn with: 20.
		agent send: incFn with: 21.
		agent await.
		agent read ] omni.
	
	self assert: 42 equals: result.! !

OcjAgentTest subclass: #OcjAgentWithImmutabilityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Tests-Languages-Clojure'!

!OcjAgentWithImmutabilityTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/6/2012 15:22'!
testImmutabilityOk
	| agent a b |
	agent := OcjAgentWithImmutability new.
	
	[ | r |
	  agent send: [:o| OcjAgentTestSuject new.].
	  agent await.
	  r := agent read.
	  a := r a.
	  b := r b. ] omni.

	self assert: #a equals: a.
	self assert: #b equals: b.! !

!OcjAgentWithImmutabilityTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/6/2012 15:30'!
testImmutabilityOkWithUseInOmniDomain
	| agent a b |
	agent := OcjAgentWithImmutability new.
	
	[ | r |
	  agent send: [:o| OcjAgentTestSuject new.].
	  agent await.
	  r := agent read.
	  a := r a.
	  b := r b. ] omni.

	self assert: #a equals: a.
	self assert: #b equals: b.
	
	[ agent send: [:o | | n |
							n := OcjAgentTestSuject new.
							n a: o.
							n].
	  agent await.
	  a := agent read] omni.

	self assert: #a equals: a a a.! !

!OcjAgentWithImmutabilityTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/6/2012 15:29'!
testImmutabilityViolation
	| agent a b |
	agent := OcjAgentWithImmutability new.
	
	[ agent send: [:o| OcjAgentTestSuject new.] ] omni.
	
	agent await.
	a := agent read.
	
	self should: [ [ a a: #foo.] omni.]
	     raise:  Error.

	self assert: #a equals: a a.! !
